// coreconsole.z.js

Jmol.Console = {
	buttons:{},
	buttonWidth:100,
	click:function(id) {
		Jmol.Console.buttons[id].console.appletConsole.doAction(Jmol.Console.buttons[id]);
	}	
}

Jmol.Console.getMousePos = function() {
	return { top: Jmol._mousePageY + 'px',
		left: Jmol._mousePageX + 'px' };
}

Jmol.Console.JSConsole = function(appletConsole) {

	this.applet = appletConsole.viewer.applet;
	this.id = this.applet._id+"_console";
	Jmol.Console.buttons[this.id] = this;
	this.appletConsole = appletConsole;
	this.input = appletConsole.input = new Jmol.Console.Input(this);
	this.output = appletConsole.output = new Jmol.Console.Output(this);

	// setup this.appletConsole.input, this.appletconsole.output
	// 
	// set up buttons, which are already made by this time: 	
	// protected JmolAbstractButton runButton, historyButton, stateButton;
  // protected JmolAbstractButton clearOutButton, clearInButton, loadButton;
  
  // I would prefer NOT to use jQueryUI for this - just simple buttons with simple actions --
  // because then we have to included it twice, once here and once in coremenu.z.js
  // But I think I know a way around that, so let's use jQueryUI if it adds value

	// TODO: positioning, tab-enabled, needs to float and be movable

	// create and insert HTML code here

	var s = '<div id="$ID" class="jmolConsole" style="display:block;background-color:yellow;width:600px;height:330px;position:absolute"><div id=$ID_title></id><div id=$ID_label1></div><div id=$ID_outputdiv></div><div id=$ID_inputdiv></div><div id=$ID_buttondiv></div></div>'

	var setBtn = function(console, btn) {
		btn.console = console;
		btn.id = console.id + "_" + btn.label.replace(/\s/g,"_");
		Jmol.Console.buttons[btn.id] = btn;
		return btn.html();
	}
	s = s.replace(/\$ID/g,this.id)
	$("body").after(s);
	this._container = $('#' + this.id);
	s = Jmol.Console.getMousePos();
	this._container.css(s);
	s = " <a href=\"javascript:Jmol.Console.buttons['"+this.id+"'].setVisible(false)\">close</a>";
	$("#" + this.id + "_label1").html(this.appletConsole.getLabel("label1") + s);
	$("#" + this.id + "_inputdiv").html('<textarea id="' + this.id + '_input" style="width:590px;height:100px"></textarea>');
	$("#" + this.id + "_outputdiv").html('<textarea id="' + this.id + '_output" style="width:590px;height:200px"></textarea>');
	
	s = setBtn(this, appletConsole.runButton)
		+ setBtn(this, appletConsole.loadButton)
		+ setBtn(this, appletConsole.clearInButton)
		+ setBtn(this, appletConsole.clearOutButton)
		+ setBtn(this, appletConsole.historyButton)
		+ setBtn(this, appletConsole.stateButton);
	$("#" + this.id + "_buttondiv").html(s);
	var me = this;
	$("#" + this.id + "_input").bind("keypress", function(event) { me.input.keyPressed(event) });
	$("#" + this.id + "_input").bind("keyup", function(event) { me.input.keyReleased(event) });

	this.setButton = function(text) {
		return new Jmol.Console.Button(this, text);
	}  

	this.setVisible = function(b) {	
		if (b)
			this._container.show();
		else
			this._container.hide();
	}
	
	this.setTitle = function(title) {
		$("#" + this.id + "_title").html() = title;
	}
}

Jmol.Console.Input = function(console) {

	this.console = console;
	
	// something like this....

	this.getText = function() {
		return $("#" + this.console.id + "_input").val();
	}

	this.setText = function(text) {
		if (text == null)
			text = "";
		$("#" + this.console.id + "_input").val(text);
	}

	this.keyPressed = function(ev) {
		var kcode = ev.which;
		var isCtrl = ev.ctrlKey;
		var mode = this.console.appletConsole.processKey(kcode, 401/*java.awt.event.KeyEvent.KEY_PRESSED*/, isCtrl);
		if ((mode & 1) == 1)
			ev.preventDefault();
		if ((mode & 2) == 2) {
			//TODO: handling CTRL-ENTER
		}
	}

	this.keyReleased = function(ev) {
		var kcode = ev.which;
		var isCtrl = ev.ctrlKey;
		var mode = this.console.appletConsole.processKey(kcode, 402/*java.awt.event.KeyEvent.KEY_RELEASED*/, isCtrl);
		if ((mode & 1) == 1)
			ev.preventDefault();
		if ((mode & 2) == 2) {
			//TODO: handling CTRL-ENTER
		}
	}

  this.getCaretPosition = function() {
    var el = $(this).get(0);
    if('selectionStart' in el)
      return el.selectionStart;
		if(!('selection' in document))
			return 0;
    el.focus();
    var sel = document.selection.createRange();
    var len = document.selection.createRange().text.length;
    sel.moveStart('character', -el.value.length);
    return sel.text.length - len;
	}

}

Jmol.Console.Output = function(console) {
	this.console = console;
		
	this.getText = function() {
		return $("#" + this.console.id + "_output").val();
	}

	this.setText = function(text) {
		if (text == null)
			text = "";
		$("#" + this.console.id + "_output").val(text);
	}
	
  this.append = function(message, att) {
		this.setText(this.getText() + message); 		 
  }
}

Jmol.Console.Button = function(text) {
	this.label = text;
}

Jmol.Console.Button.prototype.addConsoleListener = function(appletConsole) {
	this.appletConsole = appletConsole;
	Jmol.Console.buttons[this.id] = this;
}
  
Jmol.Console.Button.prototype.html = function() {
	var s = '<input type="button" id="' + this.id + '" style="width:' + Jmol.Console.buttonWidth + 'px" value="' + this.label + '" onClick="Jmol.Console.click(\'' + this.id + '\')"/>'
	return s;
}

